<?php
/**
 * Suprimentos\Repositories
 *
 * @category Php
 * @package  Suprimentos\Repositories
 * @author   matthaeuscarvalho <matthaeus.carvalho@teknisa.com>
 * @license  www.teknisa.com Teknisa
 * @link     http://localhost:9090/tecfood
 */
namespace Suprimentos\Repositories;

/**
 * Class Prodcomp
 *
 * @category Php
 * @package  Suprimentos\Repositories
 * @author   matthaeuscarvalho <matthaeus.carvalho@teknisa.com>
 * @license  www.teknisa.com Teknisa
 * @link     http://localhost:9090/tecfood
 */
class Prodcomp extends \Doctrine\ORM\EntityRepository
{
    /**
     * Verifica Produto Comprador
     *
     * @param String $nrorg      Organização
     * @param String $comprador  Comprador
     * @param String $cdprodini  Produto Inicial
     *
     * @throws \Exception
     * @return array
     */
    public function verificaProdutoComprador($nrorg, $comprador, $cdprodini){

        $sql = "SELECT PRODUTO.CDPRODUTO
                  FROM PRODCOMP, PRODUTO
                 WHERE PRODCOMP.NRORG      = :P_NRORG
                   AND PRODUTO.NRORG       = :P_NRORG
                   AND PRODCOMP.CDPRODUTO  = PRODUTO.CDPRODUTO
                   AND PRODCOMP.CDOPERADOR = :P_CDOPERADOR
                   AND :P_CDARVPROD LIKE PRODUTO.CDARVPROD || '%'";

        $paramsWhere = array(
            'P_NRORG'       => $nrorg,
            'P_CDOPERADOR'  => $comprador,
            'P_CDARVPROD'   => $cdprodini
        );

        try {
            return self::getEntityManager()->getConnection()->fetchAll($sql, $paramsWhere);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}