/* Sistemas Integrados TECNISA

Nome: 8982_SUPTRGO_LOG_SUP_FILGRUPFILI.SQL

Descrio:
   Trigger para gravar o registro de alteraes na tabela de agrupamento de filiais.

Criao:
   24/04/2007 - Raquel Cunha
*/

/* Tabela FILGRUPFILI: Agrupamento de Filiais.
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela FILGRUPFILI*/
/* Objetivo:  Gerar um log que vai registrar as alteraes na tabela Agrupamentoo de Filial,
              utilizando a tabela Geral de Logs de Operaes*/

CREATE OR REPLACE TRIGGER LOG_SUP_FILGRUPFILI
AFTER DELETE OR INSERT OR UPDATE
ON FILGRUPFILI FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN

/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF UPDATING THEN
      V_DESC   := 'Agrupamento ' || '' || :NEW.CDGRUPFILI || ' ' ||
                  'Filial '      || '' || :NEW.CDFILIAL;
      V_ITPESQ       := :NEW.CDGRUPFILI||:NEW.CDFILIAL;
      V_CDFILLOGOPER := :NEW.CDFILIAL;
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC   := 'Agrupamento ' || '' || :NEW.CDGRUPFILI || ' ' ||
                     'Filial '      || '' || :NEW.CDFILIAL;
         V_ITPESQ       := :NEW.CDGRUPFILI||:NEW.CDFILIAL;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC   := 'Agrupamento ' || '' || :OLD.CDGRUPFILI || ' ' ||
                        'Filial '      || '' || :OLD.CDFILIAL;
            V_ITPESQ       := :OLD.CDGRUPFILI||:OLD.CDFILIAL;
            V_CDFILLOGOPER := :OLD.CDFILIAL;
            V_IDTIPOOPER   := '3';
         END IF;
      END IF;
   END IF;

   V_DESC := SUBSTR(V_DESC, 1, 300);

   INSERT INTO LOGOPERA
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER,
       CDFILLOGOPER)
    VALUES
      ('FILGRUPFILI',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       V_CDFILLOGOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_SUP_FILGRUPFILI','4.11.107'); END;
/

