create or replace
PROCEDURE ETL_SAPSERV (P_DTINI IN DATE,
                       P_DTFIM IN DATE)
IS
   V_DTINI        DATE;
   V_DTFIM        DATE;
   V_DTMES        VARCHAR2(07);
   V_DTANO        VARCHAR2(04);
   V_BIM          VARCHAR2(6);
   V_TRI          VARCHAR2(6);
   V_SEM          VARCHAR2(6);
   V_TIPOFATU     VARCHAR2(30);   
   
   V_COUNTER      NUMBER := 0;
   ZERO           NUMBER := 0;
   
   V_VRCUSPONDE   FLOAT NOT NULL := 0;
   V_VRCUSTPADR   FLOAT NOT NULL := 0;
   V_TOTAEFET     FLOAT NOT NULL := 0; 
   V_VRCUSTUNAC   FLOAT NOT NULL := 0;
   
   V_VRAUX        FLOAT NOT NULL := 0; --VARIVEL PARA AUXLIAR ALGUNS CLCULOS
   V_CDSEQUENCIAL VARCHAR2(20);
BEGIN
   V_DTMES  :=  TO_CHAR(P_DTINI,'MM');
   V_DTANO  :=  TO_CHAR(P_DTINI,'YYYY');
   DELETE FROM ETL_RESUSAPSERV
   WHERE (ANETLSAPSERV > V_DTANO) OR
         (ANETLSAPSERV = V_DTANO
         AND  MEETLSAPSERV >= V_DTMES);
   DELETE FROM ETL_SAPGRTPPRAT
   WHERE (ANETLSGTPRA > V_DTANO) OR
         (ANETLSGTPRA = V_DTANO
         AND  MEETLSGTPRA >= V_DTMES);         
   COMMIT; 
   
   V_DTINI := TO_DATE('01'||TO_CHAR(P_DTINI,'MMYYYY'),'DDMMYYYY');
   WHILE (V_DTINI  <=  P_DTFIM) 
   LOOP /*Inicio do Loop por Data*/
      V_DTINI := TO_DATE('01'||TO_CHAR(V_DTINI,'MMYYYY'),'DDMMYYYY');
      V_DTFIM := LAST_DAY( V_DTINI);
       
      IF V_DTFIM > TRUNC(SYSDATE) THEN
         V_DTFIM := TRUNC(SYSDATE);   
      END IF;
       
      V_DTMES  :=  TO_CHAR(V_DTFIM,'MM');
      V_DTANO  :=  TO_CHAR(V_DTFIM,'YYYY');
      V_BIM := TRUNC ((V_DTMES - 1) / 2) + 1;
      V_TRI := TRUNC ((V_DTMES - 1) / 3) + 1;
      V_SEM := TRUNC ((V_DTMES - 1) / 6) + 1;

      FOR C_ETL IN
         (SELECT F.CDFILIAL, CDEMPRESA,
                 F.CDAREAGERE    AS CDAREAGERE,
                 F.CDGOPERAC     AS CDGOPERAC,
                 F.CDSUPERVISOR  AS CDSUPERVISOR,
                 F.CDSEGMER      AS CDSEGMER,
                 F.DTINICIALBI   AS DTINICIALBI,
                 P.CDTIPOFATUR   AS CDTIPOFATUR,
                 NVL(F.QTFUNCFILI,1) AS QTFUNCFILI
          FROM   FILIAL F,  PARAMFILIAL P
          WHERE  (F.CDFILIAL = P.CDFILIAL)
            AND  F.IDFUNCAOFILI IS NULL /*Desconsidera Regionais e Operadores Logsticos*/
            AND  F.DTINICIALBI IS NOT NULL
            AND  F.CDFILIAL = '0450'
          )
      LOOP           /*Inicio do Loop por Filial*/      
         IF TO_DATE('01'||TO_CHAR(C_ETL.DTINICIALBI,'MMYYYY'),'DDMMYYYY') <= V_DTINI THEN
            V_TIPOFATU := CASE  C_ETL.CDTIPOFATUR
                           WHEN '001'  THEN   'Gesto Direta'
                           WHEN '003'  THEN   'Mandato'
                           WHEN '004'  THEN   'Refeies e Servios'
                           WHEN '005'  THEN   'Taxa Fixa'
                           WHEN '006'  THEN   'Gesto Hospitalar'
                           WHEN '007'  THEN   'Produtos e Servios'
                           WHEN '008'  THEN   'Produtos e Servios'
                           ELSE 'Sem Tipo Faturamento'
            END;
            FOR C_SERVICO IN
               (SELECT CDSERVFILI
                FROM   SERVICO
                WHERE  CDFILIAL = C_ETL.CDFILIAL                  
                )
            LOOP
               BEGIN
                  SELECT 
                     SUM(QTDEEFET)
                  INTO
                     V_TOTAEFET
                  FROM
                     (SELECT
                         DISTINCT  C.CDSERVFILI, R.DTRETIRADA AS DTCUSTOPROD,
                         DECODE(P.IDCOMCUSPERC, 'T', C.QTCOMEFETCAR, C.QTCLIEFETCAR) AS QTDEEFET
                      FROM RETIRADA R, CARDADIA C, ITEMRETI I, TIPOPRAT T, ITLANCTOEST IT, PARAMFILIAL P
                      WHERE
                         C.CDFILIAL     = C_ETL.CDFILIAL           AND
                         C.DTCARDAPIO BETWEEN V_DTINI  AND V_DTFIM AND
                         C.CDSERVFILI   = C_SERVICO.CDSERVFILI     AND
                         C.CDFILIAL     = P.CDFILIAL               AND
                         R.CDFILIAL     = C.CDFILIAL               AND
                         R.NRCARDAPIO   = C.NRCARDAPIO             AND
                         R.CDFILIAL     = I.CDFILIAL               AND
                         R.NRCARDAPIO   = I.NRCARDAPIO             AND
                         R.NRRETIRADA   = I.NRRETIRADA             AND
                         I.CDTIPOPRAT   = T.CDTIPOPRAT(+)          AND
                         I.CDFIITLANEST = IT.CDFILIAL              AND
                         I.NRLANCESTQ   = IT.NRLANCESTQ            AND
                         I.NRSEQUITEM   = IT.NRSEQUITEM            AND
                         IT.IDTIPOMOVI  = '3'                      AND
                         IT.IDEVOLESTOQ = 'S'
                     ) A;
               EXCEPTION
                  WHEN OTHERS THEN
                     V_TOTAEFET := ZERO;                  
               END;
               
               
               FOR C_PRAT IN
               (
                SELECT VRCUSTO, QTDEEFET, CDGRTIPOPR
                FROM
                  (SELECT R.CDFILANCESTQ||C.CDSERVFILI AS CDFILISERVFILI, T.CDGRTIPOPR,
                          DECODE(P.IDCOMCUSPERC, 'T', C.QTCOMEFETCAR, C.QTCLIEFETCAR) AS QTDEEFET,
                          ((I.QTRETIRADA * PD.VRFATOCONV) * NVL(CUSTO_PRODUTO(IT.CDFILIMOVI, IT.CDPRODMOVI, NVL(P.CDTIPCUSTEST, 3), IT.DTLANCMOVI, TRUNC(SYSDATE)),0)) AS VRCUSTO
                   FROM RETIRADA R, CARDADIA C, ITEMRETI I, TIPOPRAT T, SERVICO S, ITLANCTOEST IT, PARAMFILIAL P, PRODUTO PD
                   WHERE C.CDFILIAL     = C_ETL.CDFILIAL     
                     AND C.DTCARDAPIO   BETWEEN V_DTINI  AND V_DTFIM 
                     AND C.CDSERVFILI   = C_SERVICO.CDSERVFILI 
                     AND C.CDFILIAL     = P.CDFILIAL      
                     AND R.CDFILIAL     = C.CDFILIAL      
                     AND R.NRCARDAPIO   = C.NRCARDAPIO    
                     AND R.CDFILIAL     = I.CDFILIAL      
                     AND R.NRCARDAPIO   = I.NRCARDAPIO    
                     AND R.NRRETIRADA   = I.NRRETIRADA    
                     AND I.CDTIPOPRAT   = T.CDTIPOPRAT(+) 
                     AND I.CDFIITLANEST = IT.CDFILIAL     
                     AND I.NRLANCESTQ   = IT.NRLANCESTQ   
                     AND I.NRSEQUITEM   = IT.NRSEQUITEM   
                     AND C.CDFILIAL     = S.CDFILIAL      
                     AND C.CDSERVFILI   = S.CDSERVFILI    
                     AND IT.IDTIPOMOVI  = '3'             
                     AND IT.IDEVOLESTOQ = 'S'             
                     AND I.CDPRODUTO    = PD.CDPRODUTO) C
               )
               LOOP
                  V_VRCUSTUNAC := V_VRCUSTUNAC + C_PRAT.VRCUSTO;
                  IF C_PRAT.VRCUSTO <> 0 THEN
                     INSERT INTO ETL_SAPGRTPPRAT
                     (CDSUPERVISOR,       CDGOPERAC,        CDEMPRESA,      CDFILIAL,
                     CDAREAGERE,          CDSEGMER,         CDFILISERVFILI, CDGRTIPOPR,
                     CDTPFATSGTPRA,       ANETLSGTPRA,      MEETLSGTPRA,    BIETLSGTPRA,
                     TRETLSGTPRA,         SEETLSGTPRA,      VRCUSUNITPPRAT, DTULTATUSGTPRA)
                     VALUES
                     (C_ETL.CDSUPERVISOR, C_ETL.CDGOPERAC, C_ETL.CDEMPRESA, C_ETL.CDFILIAL,
                      C_ETL.CDAREAGERE,   C_ETL.CDSEGMER,  C_ETL.CDFILIAL||C_SERVICO.CDSERVFILI,  C_PRAT.CDGRTIPOPR,
                      V_TIPOFATU,         V_DTANO,         V_DTMES,         V_BIM,
                      V_TRI,              V_SEM,           C_PRAT.VRCUSTO/C_PRAT.QTDEEFET ,    SYSDATE);
                  
                  END IF;
               END LOOP;
               
  
      --         V_VRCUSPONDE := V_VRCUSTUNAC + V_VRAUX;
               
               IF V_TOTAEFET<>0 THEN
                  V_VRCUSTUNAC := V_VRCUSTUNAC/V_TOTAEFET;
               ELSE 
                  V_VRCUSTUNAC := ZERO;
               END IF;
               
               
               
               BEGIN
                   SELECT VRCUSTPADR
                   INTO   V_VRCUSTPADR
                   FROM   CUSTPADR
                   WHERE  CDFILIAL   = C_ETL.CDFILIAL 
                     AND  CDSERVFILI = C_SERVICO.CDSERVFILI 
                     AND  DTREFCUSPADR BETWEEN V_DTINI AND V_DTFIM;
               EXCEPTION
                  WHEN OTHERS THEN
                     V_VRCUSTPADR := ZERO;
               END;
               
               IF (V_VRCUSTUNAC<>0) OR (V_VRCUSTPADR<>0) THEN
                  INSERT INTO ETL_RESUSAPSERV
                  (CDSUPERVISOR,         CDGOPERAC,                               CDEMPRESA,         CDFILIAL,                    CDAREAGERE,     
                   CDSEGMER,             CDFILISERVFILI,                          CDTPFATSAPSERV,    ANETLSAPSERV,                MEETLSAPSERV,   
                   BIETLSAPSERV,         TRETLSAPSERV,                            SEETLSAPSERV,      VRCUSUNIACUPOND,             VRCUSUNIAPADR, 
                   DTULTATUSAPSERV
                  )
                  VALUES
                  (
                   C_ETL.CDSUPERVISOR,   C_ETL.CDGOPERAC,                         C_ETL.CDEMPRESA,   C_ETL.CDFILIAL,              C_ETL.CDAREAGERE,
                   C_ETL.CDSEGMER,       C_ETL.CDFILIAL||C_SERVICO.CDSERVFILI,    V_TIPOFATU,        V_DTANO,                     V_DTMES,
                   V_BIM,                V_TRI,                                   V_SEM,             V_VRCUSTUNAC,                V_VRCUSTPADR,
                   SYSDATE);
               END IF;
               
               
              
               
               V_COUNTER := V_COUNTER + SQL%ROWCOUNT + 1;
               IF V_COUNTER >= 500 THEN
                  COMMIT;
                  V_COUNTER := ZERO;
               END IF;
            END LOOP;       /*Final do Loop por Servio*/
         END IF;            /*Final da condio da comparao de V_DTINI com C_ETL.DTINICIALBI */      
      END LOOP;             /*Final do Loop por filial*/
      V_DTINI := ADD_MONTHS(V_DTINI,1);
      COMMIT;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_SAPSERV','5.01.003'); END;
/
