/* Sistemas Integrados TECNISA
   Servios

Nome: PEDCUST_COMP_PROD

Descrio:
   Traz o custo do produto de composio
Criao:
28/07/05 - Welbert G. Moitinha
Alterao:
28/06/11 - Giancarlo Vieira de Castro 
 - Incluso do return na funo, parte do "CREATE FUNCTION" para que a funo tenha retorno.
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'PEDCUST_COMP_PROD' AND
                 TYPE = 'FN' 		      AND
	              U.UID = O.UID           AND
	              U.NAME = USER)
DROP FUNCTION PEDCUST_COMP_PROD
GO

CREATE FUNCTION PEDCUST_COMP_PROD (  @P_CDPRODUTO    VARCHAR(10),
                                     @P_CDFILIAL     VARCHAR(4),
                                     @P_TIPOCUSTO    NUMERIC,
                                     @P_QTDE         FLOAT,
                                     @P_CDLOJA       VARCHAR(4),
                                     @P_DTREFERENCIA DATETIME
                                   )RETURNS FLOAT
AS
BEGIN
   DECLARE @V_CUSTO        FLOAT;
   DECLARE @V_CDFILIAL     VARCHAR(4);
   DECLARE @V_CDALMOXARIFE VARCHAR(6);
   DECLARE @V_CDLOCALESTOQ VARCHAR(6);
   DECLARE @V_INCTREG      INTEGER;
   DECLARE @V_CDPRODUTORF    VARCHAR(10);
   DECLARE @V_CDSUBPRODUTORF VARCHAR(10);
   DECLARE @V_QTSUBPRODROTRF DOUBLE PRECISION;
   
   DECLARE @V_IDUTILLOTE VARCHAR(1);
   DECLARE @V_NRLOTEESTQ VARCHAR(20);
   DECLARE @V_NRSUBLOTE VARCHAR(4);
   
   /*O return foi adicionado para que a function retornasse os valores corretamente*/
   RETURN ROUND((TEKNISA.PEDCUST_COMP_PROD( @V_CDSUBPRODUTORF, @P_CDFILIAL, @P_TIPOCUSTO, @V_QTSUBPRODROTRF, @P_CDLOJA, @P_DTREFERENCIA )), 4);
   
END
GO

ALTER FUNCTION PEDCUST_COMP_PROD (@P_CDPRODUTO    VARCHAR(10),
                                  @P_CDFILIAL     VARCHAR(4),
                                  @P_TIPOCUSTO    NUMERIC,
                                  @P_QTDE         FLOAT,
                                  @P_CDLOJA       VARCHAR(4),
                                  @P_DTREFERENCIA DATETIME
                               )RETURNS FLOAT
AS
BEGIN
   DECLARE @V_CUSTO  DOUBLE PRECISION;
   DECLARE @V_CDFILIAL       VARCHAR(4);
   DECLARE @V_CDALMOXARIFE   VARCHAR(6);
   DECLARE @V_CDLOCALESTOQ   VARCHAR(6);
   DECLARE @V_INCTREG        INTEGER;

   DECLARE @V_CDPRODUTORF    VARCHAR(10);
   DECLARE @V_CDSUBPRODUTORF VARCHAR(10);
   DECLARE @V_QTSUBPRODROTRF DOUBLE PRECISION;

   DECLARE @V_IDUTILLOTE VARCHAR(1);
   DECLARE @V_NRLOTEESTQ VARCHAR(20);
   DECLARE @V_NRSUBLOTE VARCHAR(4);

   SET @V_CDFILIAL = @P_CDFILIAL;
   SET @V_CUSTO = 0;

   SELECT @V_INCTREG = COUNT(*)
   FROM
      ROTFABRICA
   WHERE
      (CDPRODUTO = @P_CDPRODUTO)AND
      (CDPRODUTO = CDSUBPRODUTO);

   IF(@V_INCTREG = 0)BEGIN
      SELECT @V_INCTREG = COUNT(*)
      FROM
         ROTFABLOCAL
      WHERE
         (CDPRODUTO = @P_CDPRODUTO)AND
         (CDPRODUTO = CDSUBPRODLOC);
   END;

   IF(@V_INCTREG = 0)BEGIN

      SET @V_CDFILIAL =  TEKNISA.COMP_LOCAL( @P_CDFILIAL,  @P_CDPRODUTO);

      IF( @V_CDFILIAL = 'P')BEGIN
/*PAREI AQUI*/
         DECLARE C_ROTFABRICA CURSOR FOR
            SELECT
               CDPRODUTO, CDSUBPRODUTO, QTSUBPRODROT
            FROM
               ROTFABRICA
            WHERE
               (CDPRODUTO = @P_CDPRODUTO);

         OPEN C_ROTFABRICA;
         FETCH NEXT FROM C_ROTFABRICA INTO @V_CDPRODUTORF, @V_CDSUBPRODUTORF, @V_QTSUBPRODROTRF;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SET @V_CUSTO = @V_CUSTO + ROUND((TEKNISA.PEDCUST_COMP_PROD( @V_CDSUBPRODUTORF, @P_CDFILIAL, @P_TIPOCUSTO, @V_QTSUBPRODROTRF, @P_CDLOJA, @P_DTREFERENCIA )), 4);
            FETCH NEXT FROM C_ROTFABRICA INTO @V_CDPRODUTORF, @V_CDSUBPRODUTORF, @V_QTSUBPRODROTRF;
         END
         CLOSE C_ROTFABRICA;
         DEALLOCATE C_ROTFABRICA;
         RETURN(@V_CUSTO);
      END
  ELSE BEGIN
            IF @V_CDFILIAL = 'N' BEGIN
               SET @V_CDALMOXARIFE = TEKNISA.BUSCA_ALMOX(@P_CDFILIAL, '', @P_CDPRODUTO);
               SET @V_CDLOCALESTOQ = TEKNISA.BUSCA_LOCAL(@P_CDFILIAL, '', @P_CDPRODUTO);

               SET @V_IDUTILLOTE = 'N';
               SET @V_NRLOTEESTQ = ' ';
               SET @V_NRSUBLOTE = ' ';

               SELECT @V_IDUTILLOTE = MAX(IDUTILLOTE)
                 FROM PARAMFILIAL
                WHERE CDFILIAL = @P_CDFILIAL;

        /* Foi retirado o parmetro de controle de lote por produto porque o relatrio posio de estoque
            no testa este parmetro. Estava dando diferena de custo do Pedido com o Estoque.
               IF ISNULL(@V_IDUTILLOTE, 'N') = 'S' BEGIN
                  SELECT @V_IDUTILLOTE = MAX(IDUTCTRLLOTE)
                    FROM PRODFILI
                   WHERE CDFILIAL = @P_CDFILIAL
                     AND CDPRODUTO = @P_CDPRODUTO;
               END;   */

               IF ISNULL(@V_IDUTILLOTE, 'N') = 'S' BEGIN
                  /* Passa mais um dia para data no SQL 'P_DTREFERENCIA + 1' porque a POSESTDIA grava a
                     data com mais um dia. Na funo de CUSTO no  necessrio fazer este controle. */
                  SELECT @V_NRLOTEESTQ = MIN(NRLOTEESTQ),
                         @V_NRSUBLOTE = MIN(NRSUBLOTE)
                    FROM POSESTDIA B
                   WHERE B.CDFILIAL = @P_CDFILIAL
                     AND B.CDPRODUTO = @P_CDPRODUTO
                     AND B.CDALMOXARIFE  = @V_CDALMOXARIFE
                     AND B.CDLOCALESTOQ  = @V_CDLOCALESTOQ
                     AND ABS(B.QTESTOQDIA) > 0.00001
                     AND B.DTPOSIESTQ = (SELECT MAX(P.DTPOSIESTQ)
                                           FROM POSESTDIA P
                                          WHERE P.CDFILIAL = @P_CDFILIAL
                                            AND P.CDPRODUTO = B.CDPRODUTO
                                            AND P.CDALMOXARIFE = @V_CDALMOXARIFE
                                            AND P.CDLOCALESTOQ = @V_CDLOCALESTOQ
                                            AND P.NRLOTEESTQ = B.NRLOTEESTQ
                                            AND P.NRSUBLOTE = B.NRSUBLOTE
                                            AND P.DTPOSIESTQ <= @P_DTREFERENCIA + 1);
               END;

               SET @V_CUSTO = @V_CUSTO + ROUND(TEKNISA.CUSTO_PRODUTO_LCEST(@P_CDFILIAL, @P_CDPRODUTO, @P_TIPOCUSTO, @P_DTREFERENCIA, GETDATE(),
                                                  @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ, @V_NRSUBLOTE) * @P_QTDE, 4);

            END;
         END;
      END;
   END;
   RETURN(@V_CUSTO);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'PEDCUST_COMP_PROD','5.05.004';
GO

