/*
 Tecnisa - Tecnologia em Informtica

 Nome: Gera_Ajuste_BolImp

 Descrio:
 Procedimento para gerao dos rateio dos valores de impostos
 com tratamento para reter na fonte com ajuste na contapagar.

 Chamada para criao
 @C:\Web_505\Sql\End_Conv\SqlServer\5016_DFSSTPO_Gera_Ajuste_BolImp.SQL

 */

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
	           O.NAME = 'GERA_AJUSTE_BOLIMP' AND
	           TYPE = 'P' 			     AND
              U.UID = O.UID           AND
              U.NAME = USER)

DROP PROCEDURE GERA_AJUSTE_BOLIMP
GO

CREATE PROCEDURE GERA_AJUSTE_BOLIMP
    @P_CDFILIAL    VARCHAR(04),
    @P_NRLANCTONF  VARCHAR(10),
    @P_CDFILIRECE  VARCHAR(04)
AS

   DECLARE @V_NRPARCELAS  DOUBLE PRECISION;
   DECLARE @V_VRTOTACONT  DOUBLE PRECISION;
   DECLARE @V_NRCONTADOR  DOUBLE PRECISION;
   DECLARE @V_VRACUMULADO DOUBLE PRECISION;
   DECLARE @V_VRAJUSTEBO  DOUBLE PRECISION;
   DECLARE @V_CDCLASSAJUS VARCHAR(06);
   DECLARE @V_EXISTE      INTEGER;
   DECLARE @V_MULT        DOUBLE PRECISION;

   /* VARIVEIS DO CURSOR C_AJUSTE */
   DECLARE @V_AJUSTE_VRTOTIMPONF DOUBLE PRECISION;
   DECLARE @V_AJUSTE_CDAJUCTPAG  VARCHAR(04);

   /* VARIVEIS DO CURSOR C_CNTPAG */
   DECLARE @V_CNTPAG_NRSEQVENPAG   VARCHAR(02);
   DECLARE @V_CNTPAG_DTATUAVENPAG  DATETIME;
   DECLARE @V_CNTPAG_VRATUAPAG     DOUBLE PRECISION;
   DECLARE @V_CNTPAG_CDFILIBPAG    VARCHAR(04);
   DECLARE @V_CNTPAG_NRLANBOLPAG   VARCHAR(10);
   DECLARE @V_CNTPAG_CDEMPRESA     VARCHAR(02);
   DECLARE @V_CNTPAG_NRPARCELAPAG VARCHAR(02);
   DECLARE @V_CNTPAG_CDCLASSFINA   VARCHAR(06);
   DECLARE @V_CNTPAG_CDFIMOVFLPAG  VARCHAR(04);

BEGIN

   SELECT @V_NRPARCELAS = COUNT(*), @V_VRTOTACONT = SUM(VRATUAPAG)
   FROM CONTAPAGAR
   WHERE CDFILIAL   = @P_CDFILIAL AND
         NRLANCTONF = @P_NRLANCTONF;


   DECLARE C_AJUSTE CURSOR FOR SELECT ISNULL(SUM(IT.VRTOTIMPONF),0) AS VRTOTIMPONF, I.CDAJUCTPAG
                                 FROM IMPOSNFTOT IT, IMPOSTO I
                                WHERE IT.CDFILIAL    = @P_CDFILIAL
                                  AND IT.NRLANCTONF  = @P_NRLANCTONF
                                  AND IT.CDIMPOSTO   = I.CDIMPOSTO
                                  AND I.IDTRATIMPO   = 'R'
                                  AND I.IDDESCRFONTE = 'P'
                               GROUP BY I.CDAJUCTPAG;

   OPEN C_AJUSTE;

   FETCH NEXT FROM C_AJUSTE INTO @V_AJUSTE_VRTOTIMPONF, @V_AJUSTE_CDAJUCTPAG;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_AJUSTE_VRTOTIMPONF > 0 BEGIN
         SET @V_NRCONTADOR = 1;
         SET @V_VRACUMULADO = @V_AJUSTE_VRTOTIMPONF;

         DECLARE C_CNTPAG CURSOR FOR SELECT NRSEQVENPAG,  DTATUAVENPAG, VRATUAPAG,
                                            CDFILIBPAG, NRLANBOLPAG, CDEMPRESA,
                                            NRPARCELAPAG, CDCLASSFINA, CDFIMOVFLPAG
                                       FROM CONTAPAGAR
                                      WHERE CDFILIAL   = @P_CDFILIAL
                                        AND NRLANCTONF = @P_NRLANCTONF
                                     ORDER BY NRSEQVENPAG
         OPEN C_CNTPAG;

         FETCH NEXT FROM C_CNTPAG INTO @V_CNTPAG_NRSEQVENPAG, @V_CNTPAG_DTATUAVENPAG,
                                       @V_CNTPAG_VRATUAPAG, @V_CNTPAG_CDFILIBPAG,
                                       @V_CNTPAG_NRLANBOLPAG, @V_CNTPAG_CDEMPRESA,
                                       @V_CNTPAG_NRPARCELAPAG, @V_CNTPAG_CDCLASSFINA,
                                       @V_CNTPAG_CDFIMOVFLPAG;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SET @V_EXISTE = 0;

            IF @V_NRPARCELAS = @V_NRCONTADOR BEGIN
               SET @V_VRAJUSTEBO = @V_VRACUMULADO;
            END
            ELSE BEGIN
               SET @V_VRAJUSTEBO  = ROUND((@V_AJUSTE_VRTOTIMPONF/@V_VRTOTACONT) * @V_CNTPAG_VRATUAPAG, 2);
               SET @V_VRACUMULADO = @V_VRACUMULADO - @V_VRAJUSTEBO;
            END;

            SET @V_MULT = @V_VRAJUSTEBO * -1;
            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CNTPAG_CDEMPRESA,
                                         @P_CDFILIRECE,
                                         @V_CNTPAG_DTATUAVENPAG,
                                         'E',
                                         @V_CNTPAG_CDCLASSFINA,
                                         @V_MULT,
                                         0;

            SELECT @V_EXISTE = COUNT(*)
              FROM AJBOLPAG
             WHERE CDFILIAL = @V_CNTPAG_CDFILIBPAG
               AND NRLANBOLPAG = @V_CNTPAG_NRLANBOLPAG
               AND CDAJUCTPAG = @V_AJUSTE_CDAJUCTPAG;

            IF @V_EXISTE > 0 BEGIN
               UPDATE AJBOLPAG
                  SET VRAJBOLPAG = ROUND((VRAJBOLPAG + @V_VRAJUSTEBO),2)
                WHERE CDFILIAL = @V_CNTPAG_CDFILIBPAG
                  AND NRLANBOLPAG = @V_CNTPAG_NRLANBOLPAG
                  AND CDAJUCTPAG = @V_AJUSTE_CDAJUCTPAG;

               UPDATE MOVFXAJBOLP
                  SET VRFXAJBOLPAG = ROUND((VRFXAJBOLPAG + @V_VRAJUSTEBO),2)
                WHERE CDFILIAL = @P_CDFILIRECE
                  AND NRLANBOLPAG = @V_CNTPAG_NRLANBOLPAG
                  AND CDAJUCTPAG = @V_AJUSTE_CDAJUCTPAG
                  AND CDCLASSFINA = @V_CNTPAG_CDCLASSFINA
                  AND CDEMPRESA = @V_CNTPAG_CDEMPRESA
                  AND DTMOVFLUXO = @V_CNTPAG_DTATUAVENPAG
                  AND IDMOVFLUXO = 'E'
                  AND CDFILIBOLPAG = @V_CNTPAG_CDFILIBPAG
                  AND NRLANBOLPAG = @V_CNTPAG_NRLANBOLPAG;

               UPDATE BOLETPAGAR
               	SET VRFINALBPAG   =  ROUND((VRFINALBPAG - @V_VRAJUSTEBO),2)
                WHERE CDFILIAL    = @V_CNTPAG_CDFILIBPAG  AND
                      NRLANBOLPAG = @V_CNTPAG_NRLANBOLPAG;
            END
            ELSE BEGIN
               INSERT INTO AJBOLPAG
                  (CDFILIAL, NRLANBOLPAG, CDAJUCTPAG, VRAJBOLPAG)
               VALUES
                  (@V_CNTPAG_CDFILIBPAG, @V_CNTPAG_NRLANBOLPAG, @V_AJUSTE_CDAJUCTPAG, @V_VRAJUSTEBO);

               INSERT INTO MOVFXAJBOLP
                  (CDFILIBOLPAG, NRLANBOLPAG, CDAJUCTPAG,
                   CDCLASSFINA,  CDEMPRESA,   CDFILIAL,
                   DTMOVFLUXO,   IDMOVFLUXO,  VRFXAJBOLPAG)
               VALUES
                  (@V_CNTPAG_CDFILIBPAG, @V_CNTPAG_NRLANBOLPAG, @V_AJUSTE_CDAJUCTPAG,
                   @V_CNTPAG_CDCLASSFINA, @V_CNTPAG_CDEMPRESA, @P_CDFILIRECE,
                   @V_CNTPAG_DTATUAVENPAG, 'E', @V_VRAJUSTEBO);

               UPDATE BOLETPAGAR
                  SET VRFINALBPAG   =  ROUND((VRFINALBPAG - @V_VRAJUSTEBO),2)
                WHERE CDFILIAL    = @V_CNTPAG_CDFILIBPAG  AND
                      NRLANBOLPAG = @V_CNTPAG_NRLANBOLPAG;
            END;


            SET @V_NRCONTADOR = @V_NRCONTADOR + 1;

            FETCH NEXT FROM C_CNTPAG INTO @V_CNTPAG_NRSEQVENPAG, @V_CNTPAG_DTATUAVENPAG,
                                       @V_CNTPAG_VRATUAPAG, @V_CNTPAG_CDFILIBPAG,
                                       @V_CNTPAG_NRLANBOLPAG, @V_CNTPAG_CDEMPRESA,
                                       @V_CNTPAG_NRPARCELAPAG, @V_CNTPAG_CDCLASSFINA,
                                       @V_CNTPAG_CDFIMOVFLPAG;

         END;
         CLOSE C_CNTPAG;
         DEALLOCATE C_CNTPAG;
      END;
      FETCH NEXT FROM C_AJUSTE INTO @V_AJUSTE_VRTOTIMPONF, @V_AJUSTE_CDAJUCTPAG;
   END;
   CLOSE C_AJUSTE;
   DEALLOCATE C_AJUSTE;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_AJUSTE_BOLIMP','5.05.077';
GO

